t / test-lib.shon commit completion: simplify __gitcomp and __gitcomp_nl implementations (583e4d5)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset EMAIL
  47unset LANGUAGE
  48unset $(perl -e '
  49        my @env = keys %ENV;
  50        my $ok = join("|", qw(
  51                TRACE
  52                DEBUG
  53                USE_LOOKUP
  54                TEST
  55                .*_TEST
  56                PROVE
  57                VALGRIND
  58        ));
  59        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  60        print join("\n", @vars);
  61')
  62GIT_AUTHOR_EMAIL=author@example.com
  63GIT_AUTHOR_NAME='A U Thor'
  64GIT_COMMITTER_EMAIL=committer@example.com
  65GIT_COMMITTER_NAME='C O Mitter'
  66GIT_MERGE_VERBOSITY=5
  67export GIT_MERGE_VERBOSITY
  68export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  69export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  70export EDITOR
  71
  72# Protect ourselves from common misconfiguration to export
  73# CDPATH into the environment
  74unset CDPATH
  75
  76unset GREP_OPTIONS
  77
  78case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  79        1|2|true)
  80                echo "* warning: Some tests will not work if GIT_TRACE" \
  81                        "is set as to trace on STDERR ! *"
  82                echo "* warning: Please set GIT_TRACE to something" \
  83                        "other than 1, 2 or true ! *"
  84                ;;
  85esac
  86
  87# Convenience
  88#
  89# A regexp to match 5 and 40 hexdigits
  90_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  91_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  92
  93# Zero SHA-1
  94_z40=0000000000000000000000000000000000000000
  95
  96# Line feed
  97LF='
  98'
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                # Ignore --quiet under a TAP::Harness. Saying how many tests
 131                # passed without the ok/not ok details is always an error.
 132                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 133        --with-dashes)
 134                with_dashes=t; shift ;;
 135        --no-color)
 136                color=; shift ;;
 137        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 138                valgrind=t; verbose=t; shift ;;
 139        --tee)
 140                shift ;; # was handled already
 141        --root=*)
 142                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 143                shift ;;
 144        *)
 145                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 146        esac
 147done
 148
 149if test -n "$color"; then
 150        say_color () {
 151                (
 152                TERM=$ORIGINAL_TERM
 153                export TERM
 154                case "$1" in
 155                        error) tput bold; tput setaf 1;; # bold red
 156                        skip)  tput bold; tput setaf 2;; # bold green
 157                        pass)  tput setaf 2;;            # green
 158                        info)  tput setaf 3;;            # brown
 159                        *) test -n "$quiet" && return;;
 160                esac
 161                shift
 162                printf "%s" "$*"
 163                tput sgr0
 164                echo
 165                )
 166        }
 167else
 168        say_color() {
 169                test -z "$1" && test -n "$quiet" && return
 170                shift
 171                echo "$*"
 172        }
 173fi
 174
 175error () {
 176        say_color error "error: $*"
 177        GIT_EXIT_OK=t
 178        exit 1
 179}
 180
 181say () {
 182        say_color info "$*"
 183}
 184
 185test "${test_description}" != "" ||
 186error "Test script did not set test_description."
 187
 188if test "$help" = "t"
 189then
 190        echo "$test_description"
 191        exit 0
 192fi
 193
 194exec 5>&1
 195exec 6<&0
 196if test "$verbose" = "t"
 197then
 198        exec 4>&2 3>&1
 199else
 200        exec 4>/dev/null 3>/dev/null
 201fi
 202
 203test_failure=0
 204test_count=0
 205test_fixed=0
 206test_broken=0
 207test_success=0
 208
 209test_external_has_tap=0
 210
 211die () {
 212        code=$?
 213        if test -n "$GIT_EXIT_OK"
 214        then
 215                exit $code
 216        else
 217                echo >&5 "FATAL: Unexpected exit with code $code"
 218                exit 1
 219        fi
 220}
 221
 222GIT_EXIT_OK=
 223trap 'die' EXIT
 224
 225# The semantics of the editor variables are that of invoking
 226# sh -c "$EDITOR \"$@\"" files ...
 227#
 228# If our trash directory contains shell metacharacters, they will be
 229# interpreted if we just set $EDITOR directly, so do a little dance with
 230# environment variables to work around this.
 231#
 232# In particular, quoting isn't enough, as the path may contain the same quote
 233# that we're using.
 234test_set_editor () {
 235        FAKE_EDITOR="$1"
 236        export FAKE_EDITOR
 237        EDITOR='"$FAKE_EDITOR"'
 238        export EDITOR
 239}
 240
 241test_decode_color () {
 242        awk '
 243                function name(n) {
 244                        if (n == 0) return "RESET";
 245                        if (n == 1) return "BOLD";
 246                        if (n == 30) return "BLACK";
 247                        if (n == 31) return "RED";
 248                        if (n == 32) return "GREEN";
 249                        if (n == 33) return "YELLOW";
 250                        if (n == 34) return "BLUE";
 251                        if (n == 35) return "MAGENTA";
 252                        if (n == 36) return "CYAN";
 253                        if (n == 37) return "WHITE";
 254                        if (n == 40) return "BLACK";
 255                        if (n == 41) return "BRED";
 256                        if (n == 42) return "BGREEN";
 257                        if (n == 43) return "BYELLOW";
 258                        if (n == 44) return "BBLUE";
 259                        if (n == 45) return "BMAGENTA";
 260                        if (n == 46) return "BCYAN";
 261                        if (n == 47) return "BWHITE";
 262                }
 263                {
 264                        while (match($0, /\033\[[0-9;]*m/) != 0) {
 265                                printf "%s<", substr($0, 1, RSTART-1);
 266                                codes = substr($0, RSTART+2, RLENGTH-3);
 267                                if (length(codes) == 0)
 268                                        printf "%s", name(0)
 269                                else {
 270                                        n = split(codes, ary, ";");
 271                                        sep = "";
 272                                        for (i = 1; i <= n; i++) {
 273                                                printf "%s%s", sep, name(ary[i]);
 274                                                sep = ";"
 275                                        }
 276                                }
 277                                printf ">";
 278                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
 279                        }
 280                        print
 281                }
 282        '
 283}
 284
 285nul_to_q () {
 286        perl -pe 'y/\000/Q/'
 287}
 288
 289q_to_nul () {
 290        perl -pe 'y/Q/\000/'
 291}
 292
 293q_to_cr () {
 294        tr Q '\015'
 295}
 296
 297q_to_tab () {
 298        tr Q '\011'
 299}
 300
 301append_cr () {
 302        sed -e 's/$/Q/' | tr Q '\015'
 303}
 304
 305remove_cr () {
 306        tr '\015' Q | sed -e 's/Q$//'
 307}
 308
 309# In some bourne shell implementations, the "unset" builtin returns
 310# nonzero status when a variable to be unset was not set in the first
 311# place.
 312#
 313# Use sane_unset when that should not be considered an error.
 314
 315sane_unset () {
 316        unset "$@"
 317        return 0
 318}
 319
 320test_tick () {
 321        if test -z "${test_tick+set}"
 322        then
 323                test_tick=1112911993
 324        else
 325                test_tick=$(($test_tick + 60))
 326        fi
 327        GIT_COMMITTER_DATE="$test_tick -0700"
 328        GIT_AUTHOR_DATE="$test_tick -0700"
 329        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 330}
 331
 332# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 333#
 334# This will commit a file with the given contents and the given commit
 335# message.  It will also add a tag with <message> as name.
 336#
 337# Both <file> and <contents> default to <message>.
 338
 339test_commit () {
 340        file=${2:-"$1.t"}
 341        echo "${3-$1}" > "$file" &&
 342        git add "$file" &&
 343        test_tick &&
 344        git commit -m "$1" &&
 345        git tag "$1"
 346}
 347
 348# Call test_merge with the arguments "<message> <commit>", where <commit>
 349# can be a tag pointing to the commit-to-merge.
 350
 351test_merge () {
 352        test_tick &&
 353        git merge -m "$1" "$2" &&
 354        git tag "$1"
 355}
 356
 357# This function helps systems where core.filemode=false is set.
 358# Use it instead of plain 'chmod +x' to set or unset the executable bit
 359# of a file in the working directory and add it to the index.
 360
 361test_chmod () {
 362        chmod "$@" &&
 363        git update-index --add "--chmod=$@"
 364}
 365
 366# Unset a configuration variable, but don't fail if it doesn't exist.
 367test_unconfig () {
 368        git config --unset-all "$@"
 369        config_status=$?
 370        case "$config_status" in
 371        5) # ok, nothing to unset
 372                config_status=0
 373                ;;
 374        esac
 375        return $config_status
 376}
 377
 378# Set git config, automatically unsetting it after the test is over.
 379test_config () {
 380        test_when_finished "test_unconfig '$1'" &&
 381        git config "$@"
 382}
 383
 384test_config_global () {
 385        test_when_finished "test_unconfig --global '$1'" &&
 386        git config --global "$@"
 387}
 388
 389# Use test_set_prereq to tell that a particular prerequisite is available.
 390# The prerequisite can later be checked for in two ways:
 391#
 392# - Explicitly using test_have_prereq.
 393#
 394# - Implicitly by specifying the prerequisite tag in the calls to
 395#   test_expect_{success,failure,code}.
 396#
 397# The single parameter is the prerequisite tag (a simple word, in all
 398# capital letters by convention).
 399
 400test_set_prereq () {
 401        satisfied="$satisfied$1 "
 402}
 403satisfied=" "
 404
 405test_have_prereq () {
 406        # prerequisites can be concatenated with ','
 407        save_IFS=$IFS
 408        IFS=,
 409        set -- $*
 410        IFS=$save_IFS
 411
 412        total_prereq=0
 413        ok_prereq=0
 414        missing_prereq=
 415
 416        for prerequisite
 417        do
 418                total_prereq=$(($total_prereq + 1))
 419                case $satisfied in
 420                *" $prerequisite "*)
 421                        ok_prereq=$(($ok_prereq + 1))
 422                        ;;
 423                *)
 424                        # Keep a list of missing prerequisites
 425                        if test -z "$missing_prereq"
 426                        then
 427                                missing_prereq=$prerequisite
 428                        else
 429                                missing_prereq="$prerequisite,$missing_prereq"
 430                        fi
 431                esac
 432        done
 433
 434        test $total_prereq = $ok_prereq
 435}
 436
 437test_declared_prereq () {
 438        case ",$test_prereq," in
 439        *,$1,*)
 440                return 0
 441                ;;
 442        esac
 443        return 1
 444}
 445
 446# You are not expected to call test_ok_ and test_failure_ directly, use
 447# the text_expect_* functions instead.
 448
 449test_ok_ () {
 450        test_success=$(($test_success + 1))
 451        say_color "" "ok $test_count - $@"
 452}
 453
 454test_failure_ () {
 455        test_failure=$(($test_failure + 1))
 456        say_color error "not ok - $test_count $1"
 457        shift
 458        echo "$@" | sed -e 's/^/#       /'
 459        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 460}
 461
 462test_known_broken_ok_ () {
 463        test_fixed=$(($test_fixed+1))
 464        say_color "" "ok $test_count - $@ # TODO known breakage"
 465}
 466
 467test_known_broken_failure_ () {
 468        test_broken=$(($test_broken+1))
 469        say_color skip "not ok $test_count - $@ # TODO known breakage"
 470}
 471
 472test_debug () {
 473        test "$debug" = "" || eval "$1"
 474}
 475
 476test_eval_ () {
 477        # This is a separate function because some tests use
 478        # "return" to end a test_expect_success block early.
 479        eval </dev/null >&3 2>&4 "$*"
 480}
 481
 482test_run_ () {
 483        test_cleanup=:
 484        expecting_failure=$2
 485        test_eval_ "$1"
 486        eval_ret=$?
 487
 488        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 489        then
 490                test_eval_ "$test_cleanup"
 491        fi
 492        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 493                echo ""
 494        fi
 495        return "$eval_ret"
 496}
 497
 498test_skip () {
 499        test_count=$(($test_count+1))
 500        to_skip=
 501        for skp in $GIT_SKIP_TESTS
 502        do
 503                case $this_test.$test_count in
 504                $skp)
 505                        to_skip=t
 506                        break
 507                esac
 508        done
 509        if test -z "$to_skip" && test -n "$test_prereq" &&
 510           ! test_have_prereq "$test_prereq"
 511        then
 512                to_skip=t
 513        fi
 514        case "$to_skip" in
 515        t)
 516                of_prereq=
 517                if test "$missing_prereq" != "$test_prereq"
 518                then
 519                        of_prereq=" of $test_prereq"
 520                fi
 521
 522                say_color skip >&3 "skipping test: $@"
 523                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 524                : true
 525                ;;
 526        *)
 527                false
 528                ;;
 529        esac
 530}
 531
 532test_expect_failure () {
 533        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 534        test "$#" = 2 ||
 535        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 536        export test_prereq
 537        if ! test_skip "$@"
 538        then
 539                say >&3 "checking known breakage: $2"
 540                if test_run_ "$2" expecting_failure
 541                then
 542                        test_known_broken_ok_ "$1"
 543                else
 544                        test_known_broken_failure_ "$1"
 545                fi
 546        fi
 547        echo >&3 ""
 548}
 549
 550test_expect_success () {
 551        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 552        test "$#" = 2 ||
 553        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 554        export test_prereq
 555        if ! test_skip "$@"
 556        then
 557                say >&3 "expecting success: $2"
 558                if test_run_ "$2"
 559                then
 560                        test_ok_ "$1"
 561                else
 562                        test_failure_ "$@"
 563                fi
 564        fi
 565        echo >&3 ""
 566}
 567
 568# test_external runs external test scripts that provide continuous
 569# test output about their progress, and succeeds/fails on
 570# zero/non-zero exit code.  It outputs the test output on stdout even
 571# in non-verbose mode, and announces the external script with "# run
 572# <n>: ..." before running it.  When providing relative paths, keep in
 573# mind that all scripts run in "trash directory".
 574# Usage: test_external description command arguments...
 575# Example: test_external 'Perl API' perl ../path/to/test.pl
 576test_external () {
 577        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 578        test "$#" = 3 ||
 579        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 580        descr="$1"
 581        shift
 582        export test_prereq
 583        if ! test_skip "$descr" "$@"
 584        then
 585                # Announce the script to reduce confusion about the
 586                # test output that follows.
 587                say_color "" "# run $test_count: $descr ($*)"
 588                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 589                # to be able to use them in script
 590                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 591                # Run command; redirect its stderr to &4 as in
 592                # test_run_, but keep its stdout on our stdout even in
 593                # non-verbose mode.
 594                "$@" 2>&4
 595                if [ "$?" = 0 ]
 596                then
 597                        if test $test_external_has_tap -eq 0; then
 598                                test_ok_ "$descr"
 599                        else
 600                                say_color "" "# test_external test $descr was ok"
 601                                test_success=$(($test_success + 1))
 602                        fi
 603                else
 604                        if test $test_external_has_tap -eq 0; then
 605                                test_failure_ "$descr" "$@"
 606                        else
 607                                say_color error "# test_external test $descr failed: $@"
 608                                test_failure=$(($test_failure + 1))
 609                        fi
 610                fi
 611        fi
 612}
 613
 614# Like test_external, but in addition tests that the command generated
 615# no output on stderr.
 616test_external_without_stderr () {
 617        # The temporary file has no (and must have no) security
 618        # implications.
 619        tmp=${TMPDIR:-/tmp}
 620        stderr="$tmp/git-external-stderr.$$.tmp"
 621        test_external "$@" 4> "$stderr"
 622        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 623        descr="no stderr: $1"
 624        shift
 625        say >&3 "# expecting no stderr from previous command"
 626        if [ ! -s "$stderr" ]; then
 627                rm "$stderr"
 628
 629                if test $test_external_has_tap -eq 0; then
 630                        test_ok_ "$descr"
 631                else
 632                        say_color "" "# test_external_without_stderr test $descr was ok"
 633                        test_success=$(($test_success + 1))
 634                fi
 635        else
 636                if [ "$verbose" = t ]; then
 637                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 638                else
 639                        output=
 640                fi
 641                # rm first in case test_failure exits.
 642                rm "$stderr"
 643                if test $test_external_has_tap -eq 0; then
 644                        test_failure_ "$descr" "$@" "$output"
 645                else
 646                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 647                        test_failure=$(($test_failure + 1))
 648                fi
 649        fi
 650}
 651
 652# debugging-friendly alternatives to "test [-f|-d|-e]"
 653# The commands test the existence or non-existence of $1. $2 can be
 654# given to provide a more precise diagnosis.
 655test_path_is_file () {
 656        if ! [ -f "$1" ]
 657        then
 658                echo "File $1 doesn't exist. $*"
 659                false
 660        fi
 661}
 662
 663test_path_is_dir () {
 664        if ! [ -d "$1" ]
 665        then
 666                echo "Directory $1 doesn't exist. $*"
 667                false
 668        fi
 669}
 670
 671test_path_is_missing () {
 672        if [ -e "$1" ]
 673        then
 674                echo "Path exists:"
 675                ls -ld "$1"
 676                if [ $# -ge 1 ]; then
 677                        echo "$*"
 678                fi
 679                false
 680        fi
 681}
 682
 683# test_line_count checks that a file has the number of lines it
 684# ought to. For example:
 685#
 686#       test_expect_success 'produce exactly one line of output' '
 687#               do something >output &&
 688#               test_line_count = 1 output
 689#       '
 690#
 691# is like "test $(wc -l <output) = 1" except that it passes the
 692# output through when the number of lines is wrong.
 693
 694test_line_count () {
 695        if test $# != 3
 696        then
 697                error "bug in the test script: not 3 parameters to test_line_count"
 698        elif ! test $(wc -l <"$3") "$1" "$2"
 699        then
 700                echo "test_line_count: line count for $3 !$1 $2"
 701                cat "$3"
 702                return 1
 703        fi
 704}
 705
 706# This is not among top-level (test_expect_success | test_expect_failure)
 707# but is a prefix that can be used in the test script, like:
 708#
 709#       test_expect_success 'complain and die' '
 710#           do something &&
 711#           do something else &&
 712#           test_must_fail git checkout ../outerspace
 713#       '
 714#
 715# Writing this as "! git checkout ../outerspace" is wrong, because
 716# the failure could be due to a segv.  We want a controlled failure.
 717
 718test_must_fail () {
 719        "$@"
 720        exit_code=$?
 721        if test $exit_code = 0; then
 722                echo >&2 "test_must_fail: command succeeded: $*"
 723                return 1
 724        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 725                echo >&2 "test_must_fail: died by signal: $*"
 726                return 1
 727        elif test $exit_code = 127; then
 728                echo >&2 "test_must_fail: command not found: $*"
 729                return 1
 730        fi
 731        return 0
 732}
 733
 734# Similar to test_must_fail, but tolerates success, too.  This is
 735# meant to be used in contexts like:
 736#
 737#       test_expect_success 'some command works without configuration' '
 738#               test_might_fail git config --unset all.configuration &&
 739#               do something
 740#       '
 741#
 742# Writing "git config --unset all.configuration || :" would be wrong,
 743# because we want to notice if it fails due to segv.
 744
 745test_might_fail () {
 746        "$@"
 747        exit_code=$?
 748        if test $exit_code -gt 129 -a $exit_code -le 192; then
 749                echo >&2 "test_might_fail: died by signal: $*"
 750                return 1
 751        elif test $exit_code = 127; then
 752                echo >&2 "test_might_fail: command not found: $*"
 753                return 1
 754        fi
 755        return 0
 756}
 757
 758# Similar to test_must_fail and test_might_fail, but check that a
 759# given command exited with a given exit code. Meant to be used as:
 760#
 761#       test_expect_success 'Merge with d/f conflicts' '
 762#               test_expect_code 1 git merge "merge msg" B master
 763#       '
 764
 765test_expect_code () {
 766        want_code=$1
 767        shift
 768        "$@"
 769        exit_code=$?
 770        if test $exit_code = $want_code
 771        then
 772                return 0
 773        fi
 774
 775        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 776        return 1
 777}
 778
 779# test_cmp is a helper function to compare actual and expected output.
 780# You can use it like:
 781#
 782#       test_expect_success 'foo works' '
 783#               echo expected >expected &&
 784#               foo >actual &&
 785#               test_cmp expected actual
 786#       '
 787#
 788# This could be written as either "cmp" or "diff -u", but:
 789# - cmp's output is not nearly as easy to read as diff -u
 790# - not all diff versions understand "-u"
 791
 792test_cmp() {
 793        $GIT_TEST_CMP "$@"
 794}
 795
 796# This function can be used to schedule some commands to be run
 797# unconditionally at the end of the test to restore sanity:
 798#
 799#       test_expect_success 'test core.capslock' '
 800#               git config core.capslock true &&
 801#               test_when_finished "git config --unset core.capslock" &&
 802#               hello world
 803#       '
 804#
 805# That would be roughly equivalent to
 806#
 807#       test_expect_success 'test core.capslock' '
 808#               git config core.capslock true &&
 809#               hello world
 810#               git config --unset core.capslock
 811#       '
 812#
 813# except that the greeting and config --unset must both succeed for
 814# the test to pass.
 815#
 816# Note that under --immediate mode, no clean-up is done to help diagnose
 817# what went wrong.
 818
 819test_when_finished () {
 820        test_cleanup="{ $*
 821                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 822}
 823
 824# Most tests can use the created repository, but some may need to create more.
 825# Usage: test_create_repo <directory>
 826test_create_repo () {
 827        test "$#" = 1 ||
 828        error "bug in the test script: not 1 parameter to test-create-repo"
 829        repo="$1"
 830        mkdir -p "$repo"
 831        (
 832                cd "$repo" || error "Cannot setup test environment"
 833                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 834                error "cannot run git init -- have you built things yet?"
 835                mv .git/hooks .git/hooks-disabled
 836        ) || exit
 837}
 838
 839test_done () {
 840        GIT_EXIT_OK=t
 841
 842        if test -z "$HARNESS_ACTIVE"; then
 843                test_results_dir="$TEST_DIRECTORY/test-results"
 844                mkdir -p "$test_results_dir"
 845                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 846
 847                cat >>"$test_results_path" <<-EOF
 848                total $test_count
 849                success $test_success
 850                fixed $test_fixed
 851                broken $test_broken
 852                failed $test_failure
 853
 854                EOF
 855        fi
 856
 857        if test "$test_fixed" != 0
 858        then
 859                say_color pass "# fixed $test_fixed known breakage(s)"
 860        fi
 861        if test "$test_broken" != 0
 862        then
 863                say_color error "# still have $test_broken known breakage(s)"
 864                msg="remaining $(($test_count-$test_broken)) test(s)"
 865        else
 866                msg="$test_count test(s)"
 867        fi
 868        case "$test_failure" in
 869        0)
 870                # Maybe print SKIP message
 871                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 872
 873                if test $test_external_has_tap -eq 0; then
 874                        say_color pass "# passed all $msg"
 875                        say "1..$test_count$skip_all"
 876                fi
 877
 878                test -d "$remove_trash" &&
 879                cd "$(dirname "$remove_trash")" &&
 880                rm -rf "$(basename "$remove_trash")"
 881
 882                exit 0 ;;
 883
 884        *)
 885                if test $test_external_has_tap -eq 0; then
 886                        say_color error "# failed $test_failure among $msg"
 887                        say "1..$test_count"
 888                fi
 889
 890                exit 1 ;;
 891
 892        esac
 893}
 894
 895# Test the binaries we have just built.  The tests are kept in
 896# t/ subdirectory and are run in 'trash directory' subdirectory.
 897if test -z "$TEST_DIRECTORY"
 898then
 899        # We allow tests to override this, in case they want to run tests
 900        # outside of t/, e.g. for running tests on the test library
 901        # itself.
 902        TEST_DIRECTORY=$(pwd)
 903fi
 904GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 905
 906if test -n "$valgrind"
 907then
 908        make_symlink () {
 909                test -h "$2" &&
 910                test "$1" = "$(readlink "$2")" || {
 911                        # be super paranoid
 912                        if mkdir "$2".lock
 913                        then
 914                                rm -f "$2" &&
 915                                ln -s "$1" "$2" &&
 916                                rm -r "$2".lock
 917                        else
 918                                while test -d "$2".lock
 919                                do
 920                                        say "Waiting for lock on $2."
 921                                        sleep 1
 922                                done
 923                        fi
 924                }
 925        }
 926
 927        make_valgrind_symlink () {
 928                # handle only executables, unless they are shell libraries that
 929                # need to be in the exec-path.  We will just use "#!" as a
 930                # guess for a shell-script, since we have no idea what the user
 931                # may have configured as the shell path.
 932                test -x "$1" ||
 933                test "#!" = "$(head -c 2 <"$1")" ||
 934                return;
 935
 936                base=$(basename "$1")
 937                symlink_target=$GIT_BUILD_DIR/$base
 938                # do not override scripts
 939                if test -x "$symlink_target" &&
 940                    test ! -d "$symlink_target" &&
 941                    test "#!" != "$(head -c 2 < "$symlink_target")"
 942                then
 943                        symlink_target=../valgrind.sh
 944                fi
 945                case "$base" in
 946                *.sh|*.perl)
 947                        symlink_target=../unprocessed-script
 948                esac
 949                # create the link, or replace it if it is out of date
 950                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 951        }
 952
 953        # override all git executables in TEST_DIRECTORY/..
 954        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 955        mkdir -p "$GIT_VALGRIND"/bin
 956        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 957        do
 958                make_valgrind_symlink $file
 959        done
 960        # special-case the mergetools loadables
 961        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 962        OLDIFS=$IFS
 963        IFS=:
 964        for path in $PATH
 965        do
 966                ls "$path"/git-* 2> /dev/null |
 967                while read file
 968                do
 969                        make_valgrind_symlink "$file"
 970                done
 971        done
 972        IFS=$OLDIFS
 973        PATH=$GIT_VALGRIND/bin:$PATH
 974        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 975        export GIT_VALGRIND
 976elif test -n "$GIT_TEST_INSTALLED" ; then
 977        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 978        error "Cannot run git from $GIT_TEST_INSTALLED."
 979        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 980        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 981else # normal case, use ../bin-wrappers only unless $with_dashes:
 982        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 983        if ! test -x "$git_bin_dir/git" ; then
 984                if test -z "$with_dashes" ; then
 985                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 986                fi
 987                with_dashes=t
 988        fi
 989        PATH="$git_bin_dir:$PATH"
 990        GIT_EXEC_PATH=$GIT_BUILD_DIR
 991        if test -n "$with_dashes" ; then
 992                PATH="$GIT_BUILD_DIR:$PATH"
 993        fi
 994fi
 995GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 996unset GIT_CONFIG
 997GIT_CONFIG_NOSYSTEM=1
 998GIT_ATTR_NOSYSTEM=1
 999export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1000
1001. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1002
1003if test -z "$GIT_TEST_CMP"
1004then
1005        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1006        then
1007                GIT_TEST_CMP="$DIFF -c"
1008        else
1009                GIT_TEST_CMP="$DIFF -u"
1010        fi
1011fi
1012
1013GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1014export GITPERLLIB
1015test -d "$GIT_BUILD_DIR"/templates/blt || {
1016        error "You haven't built things yet, have you?"
1017}
1018
1019if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1020then
1021        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1022        export GITPYTHONLIB
1023        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1024                error "You haven't built git_remote_helpers yet, have you?"
1025        }
1026fi
1027
1028if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1029        echo >&2 'You need to build test-chmtime:'
1030        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1031        exit 1
1032fi
1033
1034# Test repository
1035test="trash directory.$(basename "$0" .sh)"
1036test -n "$root" && test="$root/$test"
1037case "$test" in
1038/*) TRASH_DIRECTORY="$test" ;;
1039 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1040esac
1041test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1042rm -fr "$test" || {
1043        GIT_EXIT_OK=t
1044        echo >&5 "FATAL: Cannot prepare test area"
1045        exit 1
1046}
1047
1048HOME="$TRASH_DIRECTORY"
1049export HOME
1050
1051test_create_repo "$test"
1052# Use -P to resolve symlinks in our working directory so that the cwd
1053# in subprocesses like git equals our $PWD (for pathname comparisons).
1054cd -P "$test" || exit 1
1055
1056this_test=${0##*/}
1057this_test=${this_test%%-*}
1058for skp in $GIT_SKIP_TESTS
1059do
1060        case "$this_test" in
1061        $skp)
1062                say_color skip >&3 "skipping test $this_test altogether"
1063                skip_all="skip all tests in $this_test"
1064                test_done
1065        esac
1066done
1067
1068# Provide an implementation of the 'yes' utility
1069yes () {
1070        if test $# = 0
1071        then
1072                y=y
1073        else
1074                y="$*"
1075        fi
1076
1077        while echo "$y"
1078        do
1079                :
1080        done
1081}
1082
1083# Fix some commands on Windows
1084case $(uname -s) in
1085*MINGW*)
1086        # Windows has its own (incompatible) sort and find
1087        sort () {
1088                /usr/bin/sort "$@"
1089        }
1090        find () {
1091                /usr/bin/find "$@"
1092        }
1093        sum () {
1094                md5sum "$@"
1095        }
1096        # git sees Windows-style pwd
1097        pwd () {
1098                builtin pwd -W
1099        }
1100        # no POSIX permissions
1101        # backslashes in pathspec are converted to '/'
1102        # exec does not inherit the PID
1103        test_set_prereq MINGW
1104        test_set_prereq SED_STRIPS_CR
1105        ;;
1106*CYGWIN*)
1107        test_set_prereq POSIXPERM
1108        test_set_prereq EXECKEEPSPID
1109        test_set_prereq NOT_MINGW
1110        test_set_prereq SED_STRIPS_CR
1111        ;;
1112*)
1113        test_set_prereq POSIXPERM
1114        test_set_prereq BSLASHPSPEC
1115        test_set_prereq EXECKEEPSPID
1116        test_set_prereq NOT_MINGW
1117        ;;
1118esac
1119
1120test -z "$NO_PERL" && test_set_prereq PERL
1121test -z "$NO_PYTHON" && test_set_prereq PYTHON
1122test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1123test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1124
1125# Can we rely on git's output in the C locale?
1126if test -n "$GETTEXT_POISON"
1127then
1128        GIT_GETTEXT_POISON=YesPlease
1129        export GIT_GETTEXT_POISON
1130        test_set_prereq GETTEXT_POISON
1131else
1132        test_set_prereq C_LOCALE_OUTPUT
1133fi
1134
1135# Use this instead of test_cmp to compare files that contain expected and
1136# actual output from git commands that can be translated.  When running
1137# under GETTEXT_POISON this pretends that the command produced expected
1138# results.
1139test_i18ncmp () {
1140        test -n "$GETTEXT_POISON" || test_cmp "$@"
1141}
1142
1143# Use this instead of "grep expected-string actual" to see if the
1144# output from a git command that can be translated either contains an
1145# expected string, or does not contain an unwanted one.  When running
1146# under GETTEXT_POISON this pretends that the command produced expected
1147# results.
1148test_i18ngrep () {
1149        if test -n "$GETTEXT_POISON"
1150        then
1151            : # pretend success
1152        elif test "x!" = "x$1"
1153        then
1154                shift
1155                ! grep "$@"
1156        else
1157                grep "$@"
1158        fi
1159}
1160
1161# test whether the filesystem supports symbolic links
1162ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1163rm -f y
1164
1165# When the tests are run as root, permission tests will report that
1166# things are writable when they shouldn't be.
1167test -w / || test_set_prereq SANITY